/*
 * Copyright 2022 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WBLOWINGRESIDUAL_H
#define WBLOWINGRESIDUAL_H

#include "flow.h"

#include <vector>
#include <Eigen/Dense>

namespace flow
{

/**
 * @brief Formulation of transpiration boundary terms
 */
class FLOW_API BlowingResidual
{
public:
    // Newton
    static Eigen::VectorXd build(tbox::Element const &e, std::vector<double> const &phi, F0El const &f);
};

} // namespace flow
#endif //WBLOWINGRESIDUAL_H
