/*
 * Copyright 2022 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "wMedium.h"
#include "wProblem.h"
#include "wTag.h"
#include "wFct2.h"
using namespace heat;

Medium::Medium(std::shared_ptr<MshData> _msh, int no,
               std::shared_ptr<Fct2> _k, double _rhoc) : Group(_msh, no),
                                                         k(_k), rhoc(_rhoc)
{
    //pbl.media.push_back(this);
}

Medium::Medium(std::shared_ptr<MshData> _msh, std::string const &name,
               std::shared_ptr<Fct2> _k, double _rhoc) : Group(_msh, name),
                                                         k(_k), rhoc(_rhoc)
{
    std::cout << "tag=" << *tag << std::endl;
    //pbl.media.push_back(this);
}

void Medium::write(std::ostream &out) const
{
    out << "Medium on " << *tag << " with k=" << this->k << " rhoc=" << this->rhoc;
}
