// This .geo has been tested with gmsh 3.0.6 and 4.4.1 binaries for Mac and Linux

Macro Clear_all
  allVolumes[] = Volume "*";
  Recursive Delete { Volume{allVolumes[] } ; }
  allSurfaces[] = Surface "*";
  Recursive Delete { Surface{allSurfaces[] } ; }  
  allPoints[] = Point "*";
  Recursive Delete { Point{allPoints[] } ; }    
Return

Macro Compute_next_avaible_point_id
  allPoints[] = Point "*" ;
  NallPoints = #allPoints[] ;
  Printf("NallPoints %f",NallPoints);
  next_avaible_point_id = 0;
  compute_next_avaible_point_id_verbose = 0;
  For i In {0:NallPoints-1}
    If(compute_next_avaible_point_id_verbose)
      Printf("Compute_next_avaible_point_id %g, %g",i,allPoints[i]);
    EndIf
    If(allPoints[i]>= next_avaible_point_id)
      next_avaible_point_id = allPoints[i] + 1;
    EndIf
  EndFor
  Printf("Compute_next_avaible_point_id newp %g",newp);
  Printf("Compute_next_avaible_point_id next_avaible_point_id %g",next_avaible_point_id);
Return

Macro Scale_axis_mm_to_m
  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
  If(usePointID)
    c1[] = Point{point_OO};
  EndIf
  Dilate {{-c1[0],-c1[1],-c1[2]},0.001} { Volume{allVolumes[] } ; }

  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
Return

Macro Weld_bolt
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_1[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.026} {
    Surface{new_weld_line_loop};
  };
  new_volume_1 = num[1];
  num[] = Extrude {0, 0, -0.012} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_2[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.002} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_3[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, -0.006} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];
  num[] = BooleanUnion{ Volume{volume_id_1}; Delete; }{ Volume{volume_id_2}; Volume{volume_id_3}; Volume{volume_id_4}; Volume{volume_id_5}; Volume{volume_id_6}; Volume{volume_id_7}; Volume{volume_id_8}; Volume{volume_id_9}; Volume{new_volume_1}; Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Delete; };
  new_volume_1 = num[0];
Return

Macro Weld_bolt_2
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_1[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.026} {
    Surface{new_weld_line_loop};
  };
  new_volume_1 = num[1];
  num[] = Extrude {0, 0, -0.012} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_2[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.002} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_3[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, -0.006} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = curves_id_4[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, -6.25} {
    Surface{new_weld_line_loop};
  };
  new_volume_5 = num[1];  

  Recursive Delete { Volume{volume_id_4, volume_id_5}; } 

  num[] = BooleanUnion{ Volume{volume_id_1}; Delete; }{ Volume{volume_id_2}; Volume{volume_id_3}; Volume{volume_id_6}; Volume{volume_id_7}; Volume{volume_id_8}; Volume{volume_id_9}; Volume{new_volume_1}; Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Volume{new_volume_5}; Delete; };
  new_volume_1 = num[0];
Return

Macro Weld_tube
  c1[] = Point{pipe_p1};
  c2[] = Point{pipe_p2};
  center1[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};
  pipe_radius = Sqrt((c1[0]-center1[0])^2+(c1[1]-center1[1])^2+(c1[2]-center1[2])^2);

  c1[] = Point{weld_p1};
  c2[] = Point{weld_p5};
  center1[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};
  weld_radius = Sqrt((c1[0]-center1[0])^2+(c1[1]-center1[1])^2+(c1[2]-center1[2])^2);

  new_weld_p1 = newp;
  Point(new_weld_p1) = {(pipe_radius/weld_radius)*(c1[0]-center1[0])+center1[0],(pipe_radius/weld_radius)*(c1[1]-center1[1])+center1[1],(pipe_radius/weld_radius)*(c1[2]-center1[2])+center1[2]};
  new_weld_line1 = newreg; Line(new_weld_line1) = {new_weld_p1, weld_p2};
  new_weld_line2 = newreg; Line(new_weld_line2) = {weld_p2, weld_p3};
  new_weld_line3 = newreg; Line(new_weld_line3) = {weld_p3, weld_p4};
  new_weld_line4 = newreg; Line(new_weld_line4) = {weld_p4, new_weld_p1};

  new_weld_line_loop = newreg;  Line Loop(new_weld_line_loop) = {new_weld_line1,new_weld_line2,new_weld_line3,new_weld_line4};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};

  c1[]=Point{weld_p3};
  c2[]=Point{weld_p4};

  Extrude {{c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]}, {center1[0], center1[1], center1[2]}, Pi} {
    Surface{new_weld_line_loop};
  }
  Extrude {{c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]}, {center1[0], center1[1], center1[2]}, -Pi} {
    Surface{new_weld_line_loop};
  }
Return

Macro Compute_cross_and_theta
  norm_1 = Sqrt(vec_1[0]^2+vec_1[1]^2+vec_1[2]^2);
  norm_2 = Sqrt(vec_2[0]^2+vec_2[1]^2+vec_2[2]^2);

  cross[] = {vec_1[1]*vec_2[2]-vec_1[2]*vec_2[1],vec_1[2]*vec_2[0]-vec_1[0]*vec_2[2],vec_1[0]*vec_2[1]-vec_1[1]*vec_2[0]};
  norm_cross = Sqrt(cross[0]^2+cross[1]^2+cross[2]^2);

  dot = vec_1[0]*vec_2[0] + vec_1[1]*vec_2[1] + vec_1[2]*vec_2[2];

  theta = Acos(dot/(norm_1*norm_2));
Return

Macro Rotate_Axis
  allVolumes[] = Volume "*";
  If(usePointID)
    c1[] = Point{point_OX_1};
    c2[] = Point{point_OX_2};
    Printf("Rotate_Axis point_OX_1 c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
    Printf("Rotate_Axis point_OX_2 c2 (%g,%g,%g)",c2[0],c2[1],c2[2]);
  EndIf

  OX[] = {c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]};
  vec_1[] = OX[];
  vec_2[] = {1,0,0};

  Call Compute_cross_and_theta;

  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Volume{allVolumes[] } ; }

  allVolumes[] = Volume "*";
  If(usePointID)
    c3[] = Point{point_OY_1};
    c4[] = Point{point_OY_2};
    Printf("Rotate_Axis point_OY_1 c3 (%g,%g,%g)",c3[0],c3[1],c3[2]);
    Printf("Rotate_Axis point_OY_2 c4 (%g,%g,%g)",c4[0],c4[1],c4[2]);
  EndIf

  OY[] = {c4[0]-c3[0],c4[1]-c3[1],c4[2]-c3[2]};
  vec_1[] = OY[];
  vec_2[] = {0,1,0};

  Call Compute_cross_and_theta;
  
  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Volume{allVolumes[] } ; }

Return

Macro Rotate_Axis_x
  allVolumes[] = Volume "*";
  If(usePointID)
    c1[] = Point{point_OX_1};
    c2[] = Point{point_OX_2};
    Printf("Rotate_Axis point_OX_1 c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
    Printf("Rotate_Axis point_OX_2 c2 (%g,%g,%g)",c2[0],c2[1],c2[2]);
  EndIf

  OX[] = {c2[0]-c1[0],c2[1]-c1[1],0.};
  vec_1[] = OX[];
  vec_2[] = {1,0,0};

  Call Compute_cross_and_theta;

  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Volume{allVolumes[] } ; }

Return

Macro Rotate_Axis_1
  allVolumes[] = Volume "*";
  If(usePointID)
    c1[] = Point{point_OX_1};
    c2[] = Point{point_OX_2};
    Printf("Rotate_Axis point_OX_1 c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
    Printf("Rotate_Axis point_OX_2 c2 (%g,%g,%g)",c2[0],c2[1],c2[2]);
  EndIf

  OX[] = {c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]};
  vec_1[] = OX[];
  vec_2[] = {1,0,0};

  Call Compute_cross_and_theta;

  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Volume{allVolumes[] } ; }

  allVolumes[] = Volume "*";
  If(usePointID)
    c3[] = Point{point_OY_1};
    c4[] = Point{point_OY_2};
    Printf("Rotate_Axis point_OY_1 c3 (%g,%g,%g)",c3[0],c3[1],c3[2]);
    Printf("Rotate_Axis point_OY_2 c4 (%g,%g,%g)",c4[0],c4[1],c4[2]);
  EndIf

  OY[] = {c4[0]-c3[0],c4[1]-c3[1],c4[2]-c3[2]};
  vec_1[] = OY[];
  vec_2[] = {0,1,0};

  Call Compute_cross_and_theta;
  
  //Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Volume{allVolumes[] } ; }

Return

Macro Translate_Axis
  allVolumes[] = Volume "*";
  If(usePointID)
    c1[] = Point{point_OO};
    Printf("Translate_Axis point_OO c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
  EndIf
  Translate {-c1[0],-c1[1],-c1[2]} { Volume{allVolumes[] } ; }
  allVolumes[] = Volume "*";
Return

Macro Contact_disk
  c1[] = Point{point_disk_R_1};
  c2[] = Point{point_disk_R_2};

  center[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};

  R = Sqrt((c1[0]-center[0])^2+(c1[1]-center[1])^2+(c1[2]-center[2])^2);

  c1[] = Point{point_surface_disk_1};
  c2[] = Point{point_surface_disk_2};

  new_disk = newreg;
  Disk(new_disk) = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2, R, R};

  Printf("c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
  Printf("c2 (%g,%g,%g)",c2[0],c2[1],c2[2]);
  Printf("Center (%g,%g,%g) radius %g",(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2, R) ;

  BooleanFragments{ Surface{new_disk}; Delete; }{ Volume{volume_id}; Delete; }
Return

Macro Add_Optical_Axis
  If(usePointID)
    p1[] = Point{point_mirror_x};
    p2[] = Point{point_mirror_y};
    Printf("Add_Optical_Axis p1 (%g,%g,%g)",p1[0],p1[1],p1[2]);
    Printf("Add_Optical_Axis p2 (%g,%g,%g)",p2[0],p2[1],p2[2]);
  EndIf

  Printf("Add_Optical_Axis OA (%g,%g,%g)",p1[0]+Delta_x,p2[1]+Delta_y,p1[2]);

  Call Compute_next_avaible_point_id;
  OA = next_avaible_point_id;
  Point(OA) = {p1[0]+Delta_x, p2[1]+Delta_y, p1[2], 1};
  new_disk = newreg;
  Disk(new_disk) = {p1[0]+Delta_x, p2[1]+Delta_y, p1[2], R, R};

  BooleanFragments{  Point{OA}; Surface{new_disk}; Delete; }{ Volume{Mirror_id}; Delete; }
  //BooleanFragments{  Point{OA}; Delete; }{ Volume{Mirror_id}; Delete; }
Return

SetFactory("OpenCASCADE");

rerun = 0;

If(!FileExists("fused_mirror_assembly_all_mm.brep") || rerun)
  v() = ShapeFromFile("mirror_assembly.stp");

  BooleanFragments{ Volume{1,2,3,7,8,9,17,18,24,25,26,27}; Delete; }{}

  BooleanFragments{ Volume{13,15}; Delete; }{}
  BooleanFragments{ Volume{12,14}; Delete; }{}
  BooleanFragments{ Volume{10,11}; Delete; }{}

  // Fuse pipe 1
  weld_p1 = 1477;
  weld_p2 = 1478;
  weld_p3 = 1473;
  weld_p4 = 1471;
  weld_p5 = 1475;

  pipe_p1 = 898;
  pipe_p2 = 900;

  Call Weld_tube ;

  weld_p1 = 885;
  weld_p2 = 886;
  weld_p3 = 884;
  weld_p4 = 882;
  weld_p5 = 887;

  pipe_p1 = 907;
  pipe_p2 = 908;

  Call Weld_tube ;

  Recursive Delete { Volume{20,32}; }

  // Fuse pipe 2
  weld_p1 = 893;
  weld_p2 = 894;
  weld_p3 = 892;
  weld_p4 = 890;
  weld_p5 = 895;

  pipe_p1 = 932;
  pipe_p2 = 931;

  Call Weld_tube ;

  weld_p1 = 1483;
  weld_p2 = 1484;
  weld_p3 = 1482;
  weld_p4 = 1480;
  weld_p5 = 1485;

  pipe_p1 = 922;
  pipe_p2 = 924;

  Call Weld_tube ;
  Recursive Delete { Volume{21,33}; }

  // Fuse pipe 3
  weld_p1 = 1501;
  weld_p2 = 1502;
  weld_p3 = 1497;
  weld_p4 = 1495;
  weld_p5 = 1499;

  pipe_p1 = 1440;
  pipe_p2 = 1439;

  Call Weld_tube ;

  Recursive Delete { Volume{35}; }

  // Fuse pipe 4
  weld_p1 = 1493;
  weld_p2 = 1494;
  weld_p3 = 1489;
  weld_p4 = 1487;
  weld_p5 = 1491;

  pipe_p1 = 1456;
  pipe_p2 = 1455;

  Call Weld_tube ;

  Recursive Delete { Volume{34}; }

  usePointID = 0;

  // Realign the axis
  If(usePointID)
    point_OX_1 = 1928;
    point_OX_2 = 1929;

    point_OY_1 = 1925;
    point_OY_2 = 1927;
  Else
    c1[] = {6450.86,-90.1101,4467.16};
    c2[] = {6425.67,-76.908,4448.46};

    c3[] = {-7294.05,1085.32,2738.15};
    c4[] = {-7294.05,1121.25,2759.9};
  EndIf

  Call Rotate_Axis;

  If(usePointID)
    point_OO = 2008;
  Else
    c1[] = {-7294.05,2346.64,1780.06};
  EndIf

  Call Translate_Axis;

  c1[] = Point{7521};
  c2[] = Point{7519};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {0.98, 0.98, 0.98}} { Volume{37} ; }  

  c1[] = Point{7538};
  c2[] = Point{7545};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {0.98, 0.98, 1.}} { Volume{38} ; }  

  /*
  c1[] = Point{7713};
  c2[] = Point{7715};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.1, 1.1, 1.1}} { Volume{51} ; }  

  c1[] = Point{7777};
  c2[] = Point{7779};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.1, 1.1, 1.1}} { Volume{56} ; }  

  c1[] = Point{7501};
  c2[] = Point{7506};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.1, 1.1, 1.1}} { Volume{36} ; }  

  c1[] = Point{7736};
  c2[] = Point{7737};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.2, 1.2, 1.}} { Volume{53} ; }  

  c1[] = Point{7855};
  c2[] = Point{7855};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.2, 1.2, 1.}} { Volume{62} ; }  

  c1[] = Point{7620};
  c2[] = Point{7619};
  Dilate {{(c1[0]+c2[0])/2.,(c1[1]+c2[1])/2.,(c1[2]+c2[2])/2.}, {1.2, 1.2, 1.}} { Volume{44} ; }  
*/
  curves_id_1[] = {12528, 12529, 12519, 12525};
  curves_id_2[] = {12475, 12482, 12470, 12469};
  curves_id_3[] = {12399, 12396};
  curves_id_4[] = {12484, 12485};
  volume_id_1 = 45;
  volume_id_2 = 50;
  volume_id_3 = 51;
  volume_id_4 = 48;
  volume_id_5 = 49;
  volume_id_6 = 52;
  volume_id_7 = 53;
  volume_id_8 = 46;
  volume_id_9 = 47;
  Call Weld_bolt_2;

  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = { 13117, 13118, 13119, 13120, 13121, 13122, 13123, 13124};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 5} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];  
  num[] = Extrude {0, 0, -11} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];  

  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = {13089, 13080, 13079, 13078};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 2} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];  

  BooleanUnion{ Volume{new_volume_1}; Delete; }{ Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Delete; }

  curves_id_1[] = {13014, 13027, 13028, 13017};
  curves_id_2[] = {12349, 12355, 12362, 12350};
  curves_id_3[] = {12978, 12975};
  curves_id_4[] = {12364, 12365};
  volume_id_1 = 36;
  volume_id_2 = 37;
  volume_id_3 = 38;
  volume_id_4 = 42;
  volume_id_5 = 43;
  volume_id_6 = 39;
  volume_id_7 = 44;
  volume_id_8 = 40;
  volume_id_9 = 41;
  Call Weld_bolt_2;

  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = {13235, 13236, 13237, 13240, 13241, 13242};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 20} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];  
  num[] = Extrude {0, 0, -5} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];  

  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = {13218, 13220, 13223, 13224};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 2} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];  
  num[] = Extrude {0, 0, -0.07} {
    Surface{new_weld_line_loop};
  };
  new_volume_5 = num[1];    

  BooleanUnion{ Volume{79}; Delete; }{ Volume{80}; Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Volume{new_volume_5}; Delete; }
  BooleanUnion{ Volume{79}; Delete; }{ Volume{80}; Delete; }

  curves_id_1[] = {12619, 12622, 12628, 12629};
  curves_id_2[] = {12652, 12658, 12665, 12653};
  curves_id_3[] = {12583, 12580};
  curves_id_4[] = {12668, 12667};
  volume_id_1 = 54;
  volume_id_2 = 55;
  volume_id_3 = 56;
  volume_id_4 = 57;
  volume_id_5 = 58;
  volume_id_6 = 61;
  volume_id_7 = 62;
  volume_id_8 = 59;
  volume_id_9 = 60;
  //Call Weld_bolt_2;

  c1[] = Point{7855};
  c2[] = Point{7853};

  c3[] = Point{7761};

  c4[] = Point{7776};
  c5[] = Point{7778};

  dz = c3[2]-c1[2];
  
  center[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};

  D = Sqrt((c4[0]-c5[0])^2+(c4[1]-c5[1])^2+(c4[2]-c5[2])^2);
  R = D/2.;

  Recursive Delete { Volume{56}; }

  Cylinder(56) = {center[0],center[1],center[2], 0, 0, dz, R, 2*Pi};

  Call Weld_bolt_2;

  //+
  //BooleanUnion{ Volume{24}; Delete; }{ Volume{25}; Delete; }

  /*
  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = {13449, 13448, 13447, 13446, 13445, 13444, 13443, 13442};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 20} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];  
  num[] = Extrude {0, 0, -7} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];  

  new_weld_line_loop = newreg;
  Line Loop(new_weld_line_loop) = {13418, 13423, 13408, 13434, 13417, 13399};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 5} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];     
  BooleanUnion{ Volume{81}; Delete; }{ Volume{82}; Volume{83}; Delete; }
  BooleanUnion{ Volume{80}; Delete; }{ Volume{81}; Delete; }
  //BooleanUnion{ Volume{82}; Delete; }{ Volume{83}; Delete; }
  */


  //BooleanUnion{ Volume{new_volume_1}; Delete; }{ Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Delete; }
  
  Recursive Delete { Volume{3,17,18}; }
  Recursive Delete { Volume{64, 65}; }  

  BooleanUnion{ Volume{31}; Delete; }{ Volume{77}; Volume{76}; Delete; }
  BooleanUnion{ Volume{30}; Delete; }{ Volume{75}; Volume{74}; Delete; }
  BooleanUnion{ Volume{23}; Delete; }{ Volume{73}; Volume{72}; Volume{71}; Volume{70}; Delete; }
  BooleanUnion{ Volume{22}; Delete; }{ Volume{69}; Volume{68}; Volume{67}; Volume{66}; Delete; }
  
  allVolumes[] = Volume "*";
  BooleanFragments{ Volume{allVolumes[] }; Delete; }{}
  
  Recursive Delete { Volume{81}; } 

  If(usePointID)
    point_mirror_x = 945;
    point_mirror_y = 943;
  Else
    p1[] = {129.5,10,5.5};
    p2[] = {99.5,-20,5.5};
  EndIf

  Delta_x = -70;
  Delta_y = 37;

  Mirror_id = 2;
  R = 1.;

  //Call Add_Optical_Axis;  

  // Realign the axis
  If(usePointID)
    point_OX_1 = 9207;
    point_OX_2 = 9239;

    point_OY_1 = 10843;
    point_OY_2 = 10845;
  Else
    c1[] = {-135.485,130.067,53.5926};
    c2[] = {-119.545,121.737,54.3284};

    c3[] = {-177.978,53.1314,60.3884};
    c4[] = {-177.978,-46.8634,61.4069};
  EndIf

  Call Rotate_Axis_x;

  Save "fused_mirror_assembly_all_mm.brep";
  Call Clear_all;
EndIf

Merge "fused_mirror_assembly_all_mm.brep";  

Physical Volume("Mirror") = {2};
Physical Volume("Substrate") = {1};
Physical Volume("Washer 1") = {5};
Physical Volume("Washer 2") = {4};
Physical Volume("Washer 3") = {3};

Physical Volume("Shaft 1") = {8};
Physical Volume("Shaft 2") = {7};
Physical Volume("Shaft 3") = {6};  

Physical Volume("Spacer 1 part 1") = {12};
Physical Volume("Spacer 2 part 1") = {11};
Physical Volume("Spacer 3 part 1") = {9};

Physical Volume("Spacer 1 part 2") = {14};
Physical Volume("Spacer 2 part 2") = {13};
Physical Volume("Spacer 3 part 2") = {10};

Physical Volume("Holder") = {15,16};

Physical Volume("Nut 1") = {17};
Physical Volume("Nut 2") = {18};
Physical Volume("Nut 3") = {21};

Physical Volume("Holder 2") = {19,20};

Physical Volume("Pipes") = {24, 25, 26, 27};

Physical Volume("Bolts") = {22, 23, 28};

Physical Surface("Mirror surface") = {113};

Physical Surface("Cooling channels") = {521, 497, 522, 526, 525, 520, 518, 517, 516, 499, 500, 501, 509, 510, 511, 498, 502, 519, 503, 512, 524, 508, 507, 506, 515, 514, 505, 513, 504};
Physical Surface("Cooling channels") += {621, 620, 642, 619, 641};
Physical Surface("Cooling channels") += {878, 850, 803, 793, 845, 800, 795, 796, 799, 879, 876, 851, 849, 864, 865, 848, 863, 842, 784, 812, 785, 786, 811, 859, 875, 858, 841, 873, 874, 840, 787, 789, 808, 810, 788, 790, 807, 791, 839, 806, 805, 860, 870, 838, 866, 868, 869, 846, 797, 802, 801, 794, 855, 809, 877, 854, 872, 871, 852, 862, 844, 853, 847, 861, 856, 857, 867, 843, 804, 792};
Physical Surface("Cooling channels") += {970, 900, 965, 902, 904, 880, 901, 881, 903, 899, 974, 973, 967, 966, 969, 968, 971, 972};
Physical Surface("Cooling channels") += {1184, 1185, 1188, 1189, 1198, 1197, 1202, 1201, 1200, 1199, 1226, 1225, 1229, 1227, 1213, 1212, 1217, 1157, 1156, 1152, 1153, 1148, 1149, 1174, 1173, 1170, 1169, 1165, 1166, 1162, 1161, 1144, 1145, 1216, 1228, 1223, 1224, 1221, 1222, 1230, 1196, 1195, 1194, 1193};

Physical Surface("Holder x") = {736, 915, 954};
Physical Point("Holder yz") = {978};
Physical Point("Holder z") = {988};

Mesh.Algorithm = 6;
//Mesh.Algorithm3D = 4;
Mesh.CharacteristicLengthMin = 1.;
Mesh.CharacteristicLengthMax = 1.;
Mesh.MshFileVersion = 2.2;
