/*
 * Copyright 2022 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// global header of the "mirrors" module

#ifndef MIRRORS_H
#define MIRRORS_H

#if defined(WIN32)
#ifdef mirrors_EXPORTS
#define MIRRORS_API __declspec(dllexport)
#else
#define MIRRORS_API __declspec(dllimport)
#endif
#else
#define MIRRORS_API
#endif

#include "tbox.h"

/**
 * @brief this namespace avoids conflicts with similar names in 'waves'
 */
namespace mirrors
{
class Problem;
class Solver;
class Medium;
class uDirichlet;
class uNeumann;
class TDirichlet;
class TNeumann;
class TSource;
class MSurface;
class ANSYSSolution;
class ThermoMecaTerm;
}; // namespace mirrors

#endif //MIRRORS_H
